<?php
/**
* @author Mikko Rönkkö
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

$_PLUGINS->registerFunction( 'onBeforeUserProfileDisplay', 'checkForConfigUpdates','consolidatedTab' );

class consolidatedTab extends cbTabs {



	function consolidatedTab() {

	}

	function getDisplayTab($tab, $user, $ui) {

		global $mosConfig_live_site, $database, $ueConfig;

		$return='';
		$tabs=$this->_loadTabList($tab);

		$results=array();

		$i=0;

		$tabOneTwoRowsStyleToggle=array();
		$this->action=1;

		//Pass 2: generate content
		foreach($tabs AS $k => $oTab) {

			if($oTab->pluginclass!=null) {
				$return .= $this->_callTabPlugin($oTab, $user, $oTab->pluginclass, 'getDisplayTab', $oTab->pluginid);
			}
			if($oTab->fields) {
				$return .= $this->_getViewTabContents($oTab->tabid,$user);
			}
		}
		return $return;
	}


	function getEditTab($tab, $user, $ui) {
		global $database;

		$return='';
		$oTabs=$this->_loadTabList($tab);

		$i=0;
		$this->action=2;
		$this->fieldJS="";
		$results="";
		foreach($oTabs AS $oTab) {
			$oPContent="";
			$oFContent="";
			$oContent="";
 			if($oTab->pluginclass!=null) {
				$oPContent = $this->_callTabPlugin($oTab, $user, $oTab->pluginclass, 'getEditTab', $oTab->pluginid);
				$this->fieldJS .= $this->_getVarPlugin($oTab, $oTab->pluginclass, 'fieldJS', $oTab->pluginid);
			} 
			if($oTab->fields) {
				if($oTab->pluginclass!=null) $oTab->description=null;
				$oFContent = $this->_getEditTabContents($oTab,$user);
			}
			if($oPContent!="") $oContent .= $oPContent;
			if($oFContent!="") $oContent .= $oFContent;
			if($oContent!="") {

			$results .= "\n\t\t\t<table cellpadding=\"5\" cellspacing=\"0\" border=\"0\" width=\"95%\"><tr><td>";
			$results .= $oContent;
			$results .= "\n\t</td></tr></table>";

			$i++;
			}
	}
	$return .= $results;

	return $return;
	}

	
	function saveEditTab($tab, $user, $ui, $postdata) {

		global $database;
		
		$tabs=$this->_loadTabList($tab);
	
		foreach($tabs AS $oTab) {
			if($oTab->pluginclass!=null) {
				$this->_callTabPlugin($oTab, $user, $oTab->pluginclass, 'saveEditTab', $oTab->pluginid, $postdata);
			} 
		}
		
		$params=$this->params;
		$ids=$params->get($tab->tabid,'');
		
		$database->setQuery( "SELECT f.* FROM #__comprofiler_fields f, #__comprofiler_tabs t"
			. "\n WHERE f.published=1 and f.tabid= t.tabid and t.pluginclass is null and f.tabid in(".$ids.") AND t.enabled=0 and f.readonly=0" );

		$rowFields = $database->loadObjectList();

		$user_id = intval( mosGetParam( $_POST, 'id', 0 ));
		
		$row = new mosUser( $database );
		$row->load( $user_id );


		mosMakeHtmlSafe($row);

		$cbFields=new cbFields();
		$rowExtras = new moscomprofiler($database);
		for($i=0, $n=is_array($rowFields) ? count( $rowFields ) : 0; $i < $n; $i++) {
			$field=cbGetEscaped($rowFields[$i]->name);
			$value=null;
			if(isset($_POST[$rowFields[$i]->name])) {
				$value = $_POST[$rowFields[$i]->name];
			}
			$rowExtras->$field = $cbFields->prepareFieldDataSave($rowFields[$i]->type, $rowFields[$i]->name, $value);
			if ($rowExtras->$field == "" && $rowFields[$i]->required == 1 && !in_array($rowFields[$i]->type, array("delimiter", "hidden"))) {
				$reqErrors[] = getLangDefinition($rowFields[$i]->title) . " : " . unHtmlspecialchars(_UE_REQUIRED_ERROR);
			}
		}
	
		$rowExtras->id=$user->id;
		$rowExtras->user_id=$user->id;

	
		if (!$row->store()) {
			echo "<script type=\"text/javascript\"> alert('store:".html_entity_decode($row->getError())."');</script>\n";
			userEdit($option, $user_id, _UE_UPDATE, $row->getError() );
			return;
		}
	
		if($database->updateObject( '#__comprofiler', $rowExtras, 'id', false)) {
			echo "<script type=\"text/javascript\"> alert('store:".html_entity_decode($database->stderr(true))."'); window.history.go(-1); </script>\n";
		}


	}
	
	function _loadTabList($tab) {
		global $database;
		
		$params=$this->params;
		$ids=$params->get($tab->tabid,'');
		if($ids='') $ids=$params->get('consolidation','');
				
		$database->setQuery( "SELECT * FROM #__comprofiler_tabs t"
			. "\n WHERE t.enabled=0"
			. "\n AND t.tabid in (".$ids.")"
			. "\n ORDER BY t.position, t.ordering" );
		return $database->loadObjectList();
		
	}
	function _initTabPlugins(){
		global $database;
		
		$returnArray=array();
		
		$database->setQuery("select * from #__comprofiler_tabs_backup");
		$results=$database->loadObjectList();
		
		foreach($results as $result){
			$returnArray[$result->tabid]=$result;			
		}
		return $returnArray;
	}
}	// end class consolidatedTab.

?>
